# Super Table Plugin for Craft CMS

<img width="500" src="https://verbb.io/uploads/plugins/super-table/super-table-social-card.png?v=1">

Super Table is a Craft CMS field type to allow you to create powerful tables. You can utilise all your favourite native Craft field types in your tables, including Assets, Users, Entries and even Matrix. Also supports many third-party field types.

## Features

- 3 different layouts for ultimate flexibility; Row, Table and Matrix.
- Nest your fields inside Matrix blocks.
- Go crazy with 3-levels of nesting with Matrix > Super Table > Matrix.
- Static layout option - for when fields need to be grouped, but not repeatable.
- Unlimited use, free forever.

<img width="800" src="https://raw.githubusercontent.com/verbb/super-table/craft-3/docs/screenshots/rowLayout.png" style="box-shadow: 0 4px 16px rgba(0,0,0,0.08); border-radius: 4px; border: 1px solid rgba(0,0,0,0.12);">

## Documentation

Visit the [Super Table Plugin page](https://verbb.io/craft-plugins/super-table) for all documentation, guides, pricing and developer resources.

## Updating
### Updating to Craft 3.5+
Only Matrix > Super Table > Matrix field combinations are supported for 3 levels of nesting. In Craft 3.5+, it's possible for you to create different combinations, and additionally more levels of Super Table/Matrix fields, but they will not work. This was due to a lot of necessary streamlining with Craft 3.5+ changes with Matrix.

We're looking to fix this visual issue when creating your fields, but just note this when creating your fields.

### Updating to Craft 3.1+
If you're updating from Craft 3.0.x, or are experiencing error messages with content tables, please ensure you're on the latest [Super Table version](https://github.com/verbb/super-table/releases) to make use of our "Content Table Checker/Fixer".

Go to your Control Panel's Settings, click on the Super Table settings, and follow the prompts. This will not make any changes on your install, and if any errors are detected, will advise to fix them. In doing so, a backup will be created, and your Super Table fields should be corrected.

If you experience issues, but sure to post an issue here with the output of the checker of fixer tool.

## Support

Get in touch with us via the [Super Table Support page](https://verbb.io/craft-plugins/super-table/support) or by [creating a Github issue](https://github.com/verbb/super-table/issues)

## Show your Support

Super Table is licensed under the MIT license, meaning it will always be free and open source – we love free stuff! If you'd like to show your support to the plugin regardless, [Sponsor](https://github.com/sponsors/verbb) development.

<h2></h2>

<a href="https://verbb.io" target="_blank">
  <img width="100" src="https://verbb.io/assets/img/verbb-pill.svg">
</a>
